/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of GUITest.xs. Do not edit this file, edit GUITest.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "GUITest.xs"
/* X11::GUITest ($Id: GUITest.xs 209 2011-05-16 01:09:04Z ctrondlp $)
 *  
 * Copyright (c) 2003-2011  Dennis K. Paulsen, All Rights Reserved.
 * Email: ctrondlp@cpan.org
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses>.
 *
 */
#ifdef __cplusplus
extern "C" {
#endif
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#ifdef __cplusplus
}
#endif

/* Added for pre-v5.6.x Perl */
#ifndef newSVuv
#define newSVuv newSViv
#endif

#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/keysym.h>
#include <X11/extensions/XTest.h>
#include "Common.h"
#include "GUITest.h"
#include "KeyUtil.h"

/* File Level Variables */
static Display *TheXDisplay = NULL;
static int TheScreen = 0;
static WindowTable ChildWindows = {0};
static ULONG EventSendDelay = DEF_EVENT_SEND_DELAY;
static ULONG KeySendDelay = DEF_KEY_SEND_DELAY;
static int (*OldErrorHandler)(Display *, XErrorEvent *) = NULL;

/* Non Exported Utility Functions: */

/* Function: IgnoreBadWindow
 * Description: User defined error handler callback for X event errors.
 */
static int IgnoreBadWindow(Display *display, XErrorEvent *error)
{
	/* Ignore bad window errors here, handle elsewhere */
	if (error->error_code != BadWindow) {
		assert(NULL != OldErrorHandler);
		(*OldErrorHandler)(display, error);
	}
	/* Note: Return is ignored */
	return(0);
}

/* Function: SetupXDisplay
 * Description: Sets up our connection to the X server's display
 */
static void SetupXDisplay(void)
{
	int eventnum = 0, errornum = 0,
		majornum = 0, minornum = 0;

	/* Get Display Pointer */
	TheXDisplay = XOpenDisplay(NULL);
	if (TheXDisplay == NULL) {
		croak("X11::GUITest - This program is designed to run in X Windows!\n");
	}

	/* Ensure the XTest extension is available */
	if (!XTestQueryExtension(TheXDisplay, &eventnum, &errornum, 
							 &majornum, &minornum)) {
		croak("X11::GUITest - XServer %s doesn't support the XTest extensions!\n",
			  DisplayString(TheXDisplay));
	}

	TheScreen = DefaultScreen(TheXDisplay);

	/* Discard current events in queue. */	
	XSync(TheXDisplay, True);
}

/* Function: CloseXDisplay
 * Description: Closes our connection to the X server's display
 */
static void CloseXDisplay(void)
{
	if (TheXDisplay) {
		XSync(TheXDisplay, False);
		XCloseDisplay(TheXDisplay);
		TheXDisplay = NULL;
	}
}

/* Function: IsNumber
 * Description: Determines if the specified string represents a
 *              number.
 */
static BOOL IsNumber(const char *str)
{
	size_t x = 0, len = 0;

	assert(str != NULL);

	len = strlen(str);
	for (x = 0; x < len; x++) {
		if (!isdigit(str[x])) {
			return(FALSE);
		}
	}
	return(TRUE);
}

/* Function: GetRegKeySym
 * Description: Given a regular key name as a single character(i.e., a), this
 *				function obtains the appropriate keysym by calling GetKeySym(). 
 * Note: Returns TRUE (non-zero) on success, FALSE (zero) on failure.  Also,
 *       on success, sym gets set to the appropriate keysym. On failure, sym
 * 		 will get set to NoSymbol.
 */
static BOOL GetRegKeySym(const char name, KeySym *sym)
{
	#define MAX_REG_KEY 2
	static char key[MAX_REG_KEY] = "";
	
	key[0] = name;
	key[1] = NUL;

	return( GetKeySym(key, sym) );
}

/* Function: GetKeycodeFromKeysym
 * Description: Wrapper around XKeysymToKeycode.  Supports compile-time
 *              workarounds, etc.
 */
static KeyCode GetKeycodeFromKeysym(Display *display, KeySym keysym)
{
 	KeyCode kc = XKeysymToKeycode(display, keysym);
#ifdef X11_GUITEST_ALT_L_FALLBACK_META_L
	/* Xvfb lacks XK_Alt_L; fall back to XK_Meta_L */
 	if (kc == 0 && keysym == XK_Alt_L) {
 		kc = XKeysymToKeycode(display, XK_Meta_L);
	}
#endif
	return(kc);
}

/* Function: PressKeyImp
 * Description: Presses the key for the specified keysym.  Lower-level
 * 				implementation.
 * Note: Returns TRUE (non-zero) on success, FALSE (zero) on failure.
 */
static BOOL PressKeyImp(KeySym sym)
{
	KeyCode kc = 0;
	BOOL retval = 0;

	kc = GetKeycodeFromKeysym(TheXDisplay, sym);
	if (kc == 0) {
		return(FALSE);
	}

	retval = (BOOL)XTestFakeKeyEvent(TheXDisplay, kc, True, EventSendDelay);
	
	XFlush(TheXDisplay);
	return(retval);
}

/* Function: ReleaseKeyImp 
 * Description: Releases the key for the specified keysym.  Lower-level
 *			 	implementation.
 * Note: Returns TRUE (non-zero) on success, FALSE (zero) on failure.
 */
static BOOL ReleaseKeyImp(KeySym sym)
{
	KeyCode kc = 0;
	BOOL retval = 0;
	
	kc = GetKeycodeFromKeysym(TheXDisplay, sym);
	if (kc == 0) {
		return(FALSE);
	}

	retval = (BOOL)XTestFakeKeyEvent(TheXDisplay, kc, False, EventSendDelay);

	XFlush(TheXDisplay);
	return(retval);
}

/* Function: PressReleaseKeyImp
 * Description: Presses and releases the key for the specified keysym.
 * 				Also implements key send delay.  Lower-level implementation.
 * Note: Returns TRUE (non-zero) on success, FALSE (zero) on failure.
 */
static BOOL PressReleaseKeyImp(KeySym sym)
{
	if (!PressKeyImp(sym)) {
		return(FALSE);
	}
	if (!ReleaseKeyImp(sym)) {
		return(FALSE);
	}
	/* Possibly wait between(after) keystrokes */ 
	if (KeySendDelay > 0) {
		/* usleep(500 * 1000) = ~500ms */
		usleep(KeySendDelay * 1000);
	}
	return(TRUE);
}

/* Function: IsShiftNeeded
 * Description: Determines if the specified keysym needs the shift
 *				modifier. 
 * Note: Returns TRUE (non-zero) on success, FALSE (zero) on failure.
 */
static BOOL IsShiftNeeded(KeySym sym)
{
	KeySym ksl = 0, ksu = 0, *kss = NULL;
	KeyCode kc = 0;
	int syms = 0;
	BOOL needed = FALSE;
	
	kc = GetKeycodeFromKeysym(TheXDisplay, sym);
	if (!kc) {
		return(FALSE);
	}

	/* kc(grave) = kss(grave, asciitilde, ) */	
	kss = XGetKeyboardMapping(TheXDisplay, kc, 1, &syms);

	XConvertCase(sym, &ksl, &ksu);

	if (sym == kss[0] && (sym == ksl && sym == ksu)) {
		/* Not subject to case conversion */
		needed = FALSE;
	} else if (sym == ksl && sym != ksu) {
		/* Shift not needed */
		needed = FALSE;
	} else {
		/* Shift needed */
		needed = TRUE;
	}

	XFree(kss);
	return(needed);
}

/* Function: ProcessBraceSet
 * Description: Takes a brace set such as: {Tab}, {Tab 3},
 *				{Tab Tab a b c}, {PAUSE 500}, {PAUSE 500 Tab}, etc.
 *              and breaks it into components, then proceeds to press 
 *				the appropriate keys or perform the	special functionality
 *				requested (i.e., PAUSE).  Numeric elements are used in the
 *				special functionality or simply to ensure the previous key
 *				element gets pressed the specified number of times.
 * Note: Returns TRUE (non-zero) on success, FALSE (zero) on failure.
 */
static BOOL ProcessBraceSet(const char *braceset, size_t *len)
{
	enum {NONE, PAUSE, KEY}; /* Various Functionalities */
	int cmd = NONE, count = 0, i = 0;
	BOOL needshift = FALSE;
	char *buffer = NULL, *endbrc = NULL, *token = NULL;
	KeySym sym = 0;

	assert(braceset != NULL);
	assert(len != NULL);

	/* Fail if there isn't a valid brace set */
	if (*braceset != '{' || !strchr(braceset, '}')) {
		return(FALSE);
	}

	/* Create backup buffer because we are using strtok */
	buffer = (char *)safemalloc(strlen(braceset));
	if (buffer == NULL) {
		return(FALSE);
	}
	/* Ignore beginning { char */
	strcpy(buffer, &braceset[1]);

	/* Get brace end in buffer */
	endbrc = strchr(buffer, '}');
	if (endbrc == NULL) {
		safefree(buffer);
		return(FALSE);
	}
	/* If we have a quoted }, move over one character */
	if (endbrc[1] == '}') {
		endbrc++;
	}
	/* Terminate brace set */
	*endbrc = NUL;

	/* Store brace set length for calling function.  Include
	 * 2 for {} we ignored */
	*len = strlen(buffer) + 2;
	
	/* Work on the space delimited items in the buffer. */
	if ( !(token = strtok(buffer, " ")) ) {
		safefree(buffer);
		return(FALSE);
	}
	
	do { /* } while ( (token = strtok(NULL, " ")) ); */
		count = 0;
		if (IsNumber(token)) {
			/* Yes, a number, so convert it for key depresses or for command specific use */
			if ( (count = atoi(token)) <= 0 ) {
				safefree(buffer);
				return(FALSE);
			}	
		} else {
			cmd = NONE;
			/* Special functionality? */
			if (strcasecmp(token, "PAUSE") == 0) {
				/* Yes, PAUSE, so continue on to get the duration count */
				cmd = PAUSE;
				continue;	
			} else {
				/* No, just a key, so get symbol */
				cmd = KEY;
				if (!GetKeySym(token, &sym)) {
					safefree(buffer);
					return(FALSE);
				}
				needshift = IsShiftNeeded(sym);
				if (needshift) {
					PressKeyImp(XK_Shift_L);
				}
				/* Press key */
				if (!PressReleaseKeyImp(sym)) {
					if (needshift) {
						ReleaseKeyImp(XK_Shift_L);
					}
					safefree(buffer);
					return(FALSE);
				}		
				if (needshift) {
					ReleaseKeyImp(XK_Shift_L);
				}
			}
		}
		/* Handle commands that can use a specified count */
		if (count > 0) {
			switch (cmd) {
			case PAUSE:
				/* usleep(500 * 1000) = 500ms */
				usleep(count * 1000);
				break;
			case KEY:
				/* Repeat the last key if needed.  Start at iteration 2
				 * because we have already depressed key once up above */
				/* Use shift if needed */
				if (needshift) {
					PressKeyImp(XK_Shift_L);
				}
				for (i = 2; i <= count; i++) {
					/* Use sym that was already stored from above */
					if (!PressReleaseKeyImp(sym)) {
						if (needshift) {
							ReleaseKeyImp(XK_Shift_L);
						}
						safefree(buffer);
						return(FALSE);
					}
				}
				if (needshift) {
					ReleaseKeyImp(XK_Shift_L);
				}
				break;
			default:
				/* Fail, we have a count, but an unknown command! */
				safefree(buffer);
				return(FALSE);
			}; /* switch (cmd) { */
		} /* if (count > 0) { */
	} while ( (token = strtok(NULL, " ")) );	
	
	safefree(buffer);
	return(TRUE);
}
 
/* Function: SendKeysImp
 * Description: Underlying implementation of the SendKeys routine.  Read
 * 				the SendKeys documentation below for some specifics.
 * Note: Returns TRUE (non-zero) on success, FALSE (zero) on failure.
 *       Also, if you add special character handling below, also ensure
 * 		 the QuoteStringForSendKeys function is accurate in GUITest.pm.
 */
static BOOL SendKeysImp(const char *keys)
{
	KeySym sym = 0;
	size_t keyslen = 0, bracelen = 0;
	size_t x = 0;
	BOOL retval = FALSE, shift = FALSE, ctrl = FALSE, altgr = FALSE, 
		 alt = FALSE, meta = FALSE, modlock = FALSE, needshift = FALSE;

	assert(keys != NULL);

	keyslen = strlen(keys);
	for (x = 0; x < keyslen; x++) {
		switch (keys[x]) {
		/* Brace Set? of quoted/special characters (i.e. {{}, {TAB}, {F1 F2}, {PAUSE 200}) */
		case '{':
			if (!ProcessBraceSet(&keys[x], &bracelen)) {
				return(FALSE);
			}
			/* Skip past the brace set, Note: - 1 because we are at { already */
			x += (bracelen - 1);
			continue;
		/* Modifiers? */
		case '~': retval = PressReleaseKeyImp(XK_Return); break;
		case '+': /* Shift */ 
			retval = PressKeyImp(XK_Shift_L);
			shift = TRUE;
			break;
		case '^':  /* Control */
			retval = PressKeyImp(XK_Control_L);
			ctrl = TRUE;
			break;
		case '%': /* Alt */ 
			retval = PressKeyImp(XK_Alt_L);
			alt = TRUE; 
			break;
		case '#': /* Meta */
			retval = PressKeyImp(XK_Meta_L);
			meta = TRUE; 
			break;
		case (char)167: /* AltGr */
			retval = PressKeyImp(XK_ISO_Level3_Shift);
			altgr = TRUE;
			break;
		case '(': modlock = TRUE; break;
		case ')': modlock = FALSE; break;
		/* Regular Key? (a, b, c, 1, 2, 3, _, *, %), etc. */
		default:
			if (!GetRegKeySym(keys[x], &sym)) {
				return(FALSE);
			}
			/* Use shift if needed */
			needshift = IsShiftNeeded(sym);
			if (!shift && needshift) {
				PressKeyImp(XK_Shift_L);
			} 
			retval = PressReleaseKeyImp(sym);
			/* Release shift if needed */	
			if (!shift && needshift) {
				ReleaseKeyImp(XK_Shift_L);
			} 
			break;
		}; /* switch (keys[x]) { */
		/* If modlock coming up next, go on to process it */
		if (keys[x + 1] == '(') {
			continue;
		}
		/* Ensure modifiers are clear when needed */
		if (!modlock) {
			if (shift) {
				ReleaseKeyImp(XK_Shift_L); 
				shift = FALSE; 		
			}
			if (ctrl) { 
				ReleaseKeyImp(XK_Control_L); 
				ctrl = FALSE;
			}	
			if (alt) {
				ReleaseKeyImp(XK_Alt_L); 
				alt = FALSE;
			}
			if (meta) {
				ReleaseKeyImp(XK_Meta_L); 
				meta = FALSE;
			}
			if (altgr) {
				ReleaseKeyImp(XK_ISO_Level3_Shift);
				altgr = FALSE;
			}
		}
		if (!retval) {
			return(FALSE);
		}
	} /* for (x =  0; x < keyslen; x++) { */

	return(TRUE);
}

/* Function: IsWindowImp
 * Description: Underlying implementation of the IsWindow routine.  Read
 *				the IsWindow documentation below for some specifics.
 * Note: Returns non-zero for true, zero for false.
 */
static BOOL IsWindowImp(Window win)
{
	XWindowAttributes wattrs = {0};
	BOOL retval;

	OldErrorHandler = XSetErrorHandler(IgnoreBadWindow);
	retval = (BOOL)(XGetWindowAttributes(TheXDisplay, win, &wattrs) != 0);
	XSetErrorHandler(OldErrorHandler);
	return(retval);
}

/* Function: AddChildWindow
 * Description: Adds the specified window Id to the internally managed
 *				table of available window Ids.  Also handles the memory
 *				allocation for this table.
 * Note: Returns TRUE (non-zero) on success, FALSE (zero) on failure.
 */
static BOOL AddChildWindow(Window win)
{
	enum {INIT = 1, GROW = 2}; /* Memory Allocation */

	if (!win) {
		return(FALSE);
	}

	if (ChildWindows.Ids == NULL) {
		/* Initialize */
		ChildWindows.Ids = (Window *)safemalloc(INIT * sizeof(Window));
		if (ChildWindows.Ids == NULL) {
			return(FALSE);
		}
		ChildWindows.Max = INIT;
		ChildWindows.NVals = 0;
	} else if (ChildWindows.NVals >= ChildWindows.Max) {
		/* Grow */
		/* Note: Did not use [insert fancy algorythm name here] algorythm here on purpose */
		Window *TempIds = NULL;
		TempIds = (Window *)saferealloc(ChildWindows.Ids, 
						(GROW * ChildWindows.Max) * sizeof(Window));
		if (TempIds == NULL) {
			return(FALSE);
		}
		ChildWindows.Max *= GROW;
		ChildWindows.Ids = TempIds;
	}
	/* Place the new window Id in */
	ChildWindows.Ids[ChildWindows.NVals] = win;
	ChildWindows.NVals++;

	return(TRUE);
}

/* Function: ClearChildWindows
 * Description: Clears the table of window Ids.  Memory allocated
 *				in AddChildWindow is not freed here, because
 *				we'll probably want to take advantage of it again. 
 * Note: No return value.
 */
static void ClearChildWindows(void)
{
	if (ChildWindows.Ids) {
		memset(ChildWindows.Ids, 0, ChildWindows.Max * sizeof(Window));
	}
	ChildWindows.NVals = 0;
}

/* Function: FreeChildWindows
 * Description: Deallocates the memory of the window Id table
 * 				that was allocated through AddChildWindow.  This
 *				should be called on exit. 
 * Note: No return value.
 */
static void FreeChildWindows(void)
{
	if (ChildWindows.Ids) {
		safefree(ChildWindows.Ids);
		ChildWindows.Ids = NULL;
	}
	ChildWindows.NVals = 0;
	ChildWindows.Max = 0;
}

/* Function: EnumChildWindowsAux
 * Description: Obtains the list of window Ids
 * Note: Returns value indicating success of obtaining
 *       windows.
 */
static BOOL EnumChildWindowsAux(Window win)
{
   	Window root = 0, parent = 0, *children = NULL;
   	UINT childcount = 0;
	UINT i = 0;

	/* get list of child windows */
	if (XQueryTree(TheXDisplay, win, &root, &parent, &children, 
				   &childcount)) {
	   	for (i = 0; i < childcount; i++) {
			/* Add Child */
			AddChildWindow(children[i]);
			/* Look for its descendents */
	   		if (!EnumChildWindowsAux(children[i])) {
				XFree(children);
				return FALSE;
			}
   		}
   		if (children) {
       		XFree(children);
   		}
		return TRUE;
	} else {
		return FALSE;
	}
}

/* Function: EnumChildWindows
 * Description: Calls utility function to obtain list of window
 *              Ids.  Helps handle window transitions.
 * Note: Returns nothing.
 */
static void EnumChildWindows(Window win)
{
	BOOL success = 0;
	
	for (;;) {
		if (!IsWindowImp(win)) {
			return;
		}

		OldErrorHandler = XSetErrorHandler(IgnoreBadWindow);
		success = EnumChildWindowsAux(win);
		XSetErrorHandler(OldErrorHandler);
		if (success) {
			return;
		}
		/* Failure: try again, in 1/2 second. */
		ClearChildWindows();
		usleep(500000); /* 500000 = 1/2 second */
	}
}

#line 659 "GUITest.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 803 "GUITest.c"

XS_EUPXS(XS_X11__GUITest_InitGUITest); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest_InitGUITest)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 655 "GUITest.xs"
	/* Things to do on initialization */
	SetupXDisplay();
	XTestGrabControl(TheXDisplay, True);
	XSRETURN(0);
#line 819 "GUITest.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_X11__GUITest_DeInitGUITest); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest_DeInitGUITest)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 663 "GUITest.xs"
	/* Things to do on deinitialization */
	CloseXDisplay();
	FreeChildWindows();
	XSRETURN(0);
#line 840 "GUITest.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_X11__GUITest_DefaultScreen); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest_DefaultScreen)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;
#line 672 "GUITest.xs"
	RETVAL = TheScreen;
#line 858 "GUITest.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_X11__GUITest_ScreenCount); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest_ScreenCount)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;
#line 680 "GUITest.xs"
	RETVAL = ScreenCount(TheXDisplay);
#line 877 "GUITest.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_X11__GUITest_SetEventSendDelay); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest_SetEventSendDelay)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "delay");
    {
	ULONG	delay = (ULONG)SvUV(ST(0))
;
	ULONG	RETVAL;
	dXSTARG;
#line 689 "GUITest.xs"
	/* Returning old delay amount */
	RETVAL = EventSendDelay;
	EventSendDelay = delay;
#line 900 "GUITest.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_X11__GUITest_GetEventSendDelay); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest_GetEventSendDelay)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	ULONG	RETVAL;
	dXSTARG;
#line 699 "GUITest.xs"
	RETVAL = EventSendDelay;
#line 919 "GUITest.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_X11__GUITest_SetKeySendDelay); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest_SetKeySendDelay)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "delay");
    {
	ULONG	delay = (ULONG)SvUV(ST(0))
;
	ULONG	RETVAL;
	dXSTARG;
#line 708 "GUITest.xs"
	/* Returning old delay amount */
	RETVAL = KeySendDelay;
	KeySendDelay = delay;
#line 942 "GUITest.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_X11__GUITest_GetKeySendDelay); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest_GetKeySendDelay)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	ULONG	RETVAL;
	dXSTARG;
#line 718 "GUITest.xs"
	RETVAL = KeySendDelay;
#line 961 "GUITest.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_X11__GUITest_GetWindowName); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest_GetWindowName)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "win");
    {
	Window	win = (Window)SvUV(ST(0))
;
#line 727 "GUITest.xs"
	char *name = NULL;
#line 980 "GUITest.c"
	SV *	RETVAL;
#line 729 "GUITest.xs"
	if (IsWindowImp(win) && XFetchName(TheXDisplay, win, &name)) {
		RETVAL = newSVpv(name, strlen(name));
		XFree(name);
	} else {
		RETVAL = &PL_sv_undef; 
	}
#line 989 "GUITest.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_X11__GUITest_SetWindowName); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest_SetWindowName)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "win, name");
    {
	Window	win = (Window)SvUV(ST(0))
;
	char *	name = (char *)SvPV_nolen(ST(1))
;
#line 744 "GUITest.xs"
	XTextProperty textprop = {0};
	size_t namelen = 0;
	Atom utf8_string = 0;
	Atom net_wm_name = 0;
	Atom net_wm_icon_name = 0;
#line 1014 "GUITest.c"
	BOOL	RETVAL;
	dXSTARG;
#line 750 "GUITest.xs"
	RETVAL = FALSE;
	if (IsWindowImp(win)) {
		if (XStringListToTextProperty(&name, 1, &textprop)) {
			XSetWMName(TheXDisplay, win, &textprop);
			XSetWMIconName(TheXDisplay, win, &textprop);
			XFree(textprop.value);
			RETVAL = TRUE;
		}
		/* These UTF8 window name properties can be the properties
		 * that get displayed, so we set them too. */
		utf8_string = XInternAtom(TheXDisplay, "UTF8_STRING", True);
		if (utf8_string != None) {
			net_wm_name = XInternAtom(TheXDisplay, "_NET_WM_NAME", True);
			net_wm_icon_name = XInternAtom(TheXDisplay, "_NET_WM_ICON_NAME", True);
			if (net_wm_name != None && net_wm_icon_name != None) {
				namelen = strlen(name);
				XChangeProperty(TheXDisplay, win, net_wm_name, utf8_string, 8,
								PropModeReplace, (unsigned char *)name, namelen);
				XChangeProperty(TheXDisplay, win, net_wm_icon_name, utf8_string, 8,
								PropModeReplace, (unsigned char *)name, namelen);
			}
		}
	}	
#line 1041 "GUITest.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_X11__GUITest_GetRootWindow); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest_GetRootWindow)
{
    dVAR; dXSARGS;
    if (items < 0 || items > 1)
       croak_xs_usage(cv,  "scr_num = NO_INIT");
    {
	int	scr_num;
	Window	RETVAL;
	dXSTARG;

	if (items >= 1) {
	    scr_num = (int)SvIV(ST(0))
;
	}
#line 781 "GUITest.xs"
	if (0 == items)
		scr_num = TheScreen;
	if (scr_num >= 0 && scr_num < ScreenCount(TheXDisplay))
		RETVAL = RootWindow(TheXDisplay, scr_num);
	else
		RETVAL = None;
#line 1071 "GUITest.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_X11__GUITest_GetChildWindows); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest_GetChildWindows)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "win");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Window	win = (Window)SvUV(ST(0))
;
#line 795 "GUITest.xs"
	UINT i = 0;
#line 1092 "GUITest.c"
#line 797 "GUITest.xs"
	EnumChildWindows(win);
	EXTEND(SP, (int)ChildWindows.NVals);
	for (i = 0; i < ChildWindows.NVals; i++) {
		PUSHs(sv_2mortal(newSVuv((UV)ChildWindows.Ids[i])));
	}
	ClearChildWindows();
	XSRETURN(i);
#line 1101 "GUITest.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_X11__GUITest_MoveMouseAbs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest_MoveMouseAbs)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "x, y, scr_num = NO_INIT");
    {
	int	x = (int)SvIV(ST(0))
;
	int	y = (int)SvIV(ST(1))
;
	int	scr_num;
	BOOL	RETVAL;
	dXSTARG;

	if (items >= 3) {
	    scr_num = (int)SvIV(ST(2))
;
	}
#line 812 "GUITest.xs"
	if (items < 3)
		scr_num = TheScreen;
	if (scr_num >= 0 && scr_num < ScreenCount(TheXDisplay)) {
#ifndef X11_GUITEST_USING_XINERAMA
		RETVAL = (BOOL)XTestFakeMotionEvent(TheXDisplay, scr_num, x, y,
						    EventSendDelay);
		XFlush(TheXDisplay);
#else
		ULONG tmp;

		    /* I decided not to set our error handler, since the
		       window must exist. */
		XWarpPointer(TheXDisplay, None,
			     RootWindow(TheXDisplay, scr_num),
			     0, 0, 0, 0,
			     x, y);
		XSync(TheXDisplay, False);
		tmp = EventSendDelay / (ULONG) 1000;
		while ((ULONG) 0 != tmp)
			tmp = (ULONG) sleep((int) tmp);
		tmp = EventSendDelay % (ULONG) 1000;
		usleep(1000 * tmp);
#endif
		RETVAL = (BOOL) 1;
	} else {
		RETVAL = (BOOL) 0;
	}
#line 1155 "GUITest.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_X11__GUITest_GetMousePos); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest_GetMousePos)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 846 "GUITest.xs"
	Window root = 0, child = 0;
	int root_x = 0, root_y = 0;
	int win_x = 0, win_y = 0, scr_num = 0;
	UINT mask = 0;
#line 1177 "GUITest.c"
#line 851 "GUITest.xs"
		/* We do not bother to set our error handler because the
		   window given has to exist. */
	XQueryPointer(TheXDisplay, RootWindow(TheXDisplay, TheScreen),
		      &root, &child, &root_x, &root_y, &win_x, &win_y, &mask);
	EXTEND(SP, 3);
	PUSHs( sv_2mortal(newSViv((IV)root_x)) );
	PUSHs( sv_2mortal(newSViv((IV)root_y)) );
	for (scr_num = ScreenCount(TheXDisplay) - 1; scr_num >= 0 ; --scr_num)
	{
		if (root == RootWindow(TheXDisplay, scr_num)) {
			break;
		}
		assert(0 != scr_num);
		/* There is something really wrong with the Xlib data
		   if this "assert" fails. */
	}
	PUSHs( sv_2mortal(newSViv((IV)scr_num)) );
	XSRETURN(3);
#line 1197 "GUITest.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_X11__GUITest_PressMouseButton); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest_PressMouseButton)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "button");
    {
	int	button = (int)SvIV(ST(0))
;
	BOOL	RETVAL;
	dXSTARG;
#line 875 "GUITest.xs"
	RETVAL = (BOOL)XTestFakeButtonEvent(TheXDisplay, button, True, EventSendDelay);
	XFlush(TheXDisplay);
#line 1218 "GUITest.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_X11__GUITest_ReleaseMouseButton); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest_ReleaseMouseButton)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "button");
    {
	int	button = (int)SvIV(ST(0))
;
	BOOL	RETVAL;
	dXSTARG;
#line 885 "GUITest.xs"
	RETVAL = (BOOL)XTestFakeButtonEvent(TheXDisplay, button, False, EventSendDelay);
	XFlush(TheXDisplay);
#line 1240 "GUITest.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_X11__GUITest_SendKeys); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest_SendKeys)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "keys");
    {
	char *	keys = (char *)SvPV_nolen(ST(0))
;
	BOOL	RETVAL;
	dXSTARG;
#line 895 "GUITest.xs"
	RETVAL = SendKeysImp(keys);
#line 1261 "GUITest.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_X11__GUITest_PressKey); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest_PressKey)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "key");
    {
	char *	key = (char *)SvPV_nolen(ST(0))
;
#line 904 "GUITest.xs"
	KeySym sym = 0;
#line 1280 "GUITest.c"
	BOOL	RETVAL;
	dXSTARG;
#line 906 "GUITest.xs"
	RETVAL = GetKeySym(key, &sym);
	if (RETVAL) {
		RETVAL = PressKeyImp(sym);
	}
#line 1288 "GUITest.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_X11__GUITest_ReleaseKey); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest_ReleaseKey)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "key");
    {
	char *	key = (char *)SvPV_nolen(ST(0))
;
#line 918 "GUITest.xs"
	KeySym sym = 0;
#line 1307 "GUITest.c"
	BOOL	RETVAL;
	dXSTARG;
#line 920 "GUITest.xs"
	RETVAL = GetKeySym(key, &sym);
	if (RETVAL) {
		RETVAL = ReleaseKeyImp(sym);
	}
#line 1315 "GUITest.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_X11__GUITest_PressReleaseKey); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest_PressReleaseKey)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "key");
    {
	char *	key = (char *)SvPV_nolen(ST(0))
;
#line 932 "GUITest.xs"
	KeySym sym = 0;
#line 1334 "GUITest.c"
	BOOL	RETVAL;
	dXSTARG;
#line 934 "GUITest.xs"
	RETVAL = GetKeySym(key, &sym);
	if (RETVAL) {
		RETVAL = PressReleaseKeyImp(sym);
	}
#line 1342 "GUITest.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_X11__GUITest_IsKeyPressed); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest_IsKeyPressed)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "key");
    {
	char *	key = (char *)SvPV_nolen(ST(0))
;
#line 946 "GUITest.xs"
	int pos = 0;
	KeySym sym = 0;
	KeyCode kc = 0, skc = 0;
	BOOL keyon = FALSE, shifton = FALSE;
	char keys_return[KEYMAP_VECTOR_SIZE] = "";
#line 1365 "GUITest.c"
	BOOL	RETVAL;
	dXSTARG;
#line 952 "GUITest.xs"
	if (key && GetKeySym(key, &sym)) {
		kc = GetKeycodeFromKeysym(TheXDisplay, sym);
		skc = GetKeycodeFromKeysym(TheXDisplay, XK_Shift_L); 
		XQueryKeymap(TheXDisplay, keys_return);
		for (pos = 0; pos < (KEYMAP_VECTOR_SIZE * KEYMAP_BIT_COUNT); pos++) {
			/* For the derived keycode, are we at the correct bit position for it? */
			if (kc == pos) {
				/* Check the bit at this position to determine the state of the key */
				if ( keys_return[pos / KEYMAP_BIT_COUNT] & (1 << (pos % KEYMAP_BIT_COUNT)) ) {
					/* Bit On, so key is pressed */
					keyon = TRUE;
				}
			}
			/* For the shift keycode, ... */
			if (skc == pos) {
				/* Check the bit at this position to determine the state of the shift key */
				if ( keys_return[pos / KEYMAP_BIT_COUNT] & (1 << (pos % KEYMAP_BIT_COUNT)) ) {
					/* Bit On, so shift is pressed */
					shifton = TRUE;
				}
			}
		} /* for (pos = 0; pos < (KEYMAP_VECTOR_SIZE * KEYMAP_BIT_COUNT); pos++) { */
	} /* if (key && GetKeySym(key, &sym)) { */

	/* Determine result */
	if (keyon) {
		/* Key is on, so use its keysym to determine if shift modifier needs to be verified also */
		if (IsShiftNeeded(sym)) {
			RETVAL = (shifton);
		} else {
			RETVAL = (!shifton);	
		}
	} else {
		/* Key not on, so it is not pressed */
		RETVAL = FALSE;
	}
#line 1405 "GUITest.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_X11__GUITest_IsMouseButtonPressed); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest_IsMouseButtonPressed)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "button");
    {
	int	button = (int)SvIV(ST(0))
;
#line 996 "GUITest.xs"
	Window root = 0, child = 0;
	int root_x = 0, root_y = 0;
	int win_x = 0, win_y = 0;
	UINT mask = 0;
#line 1427 "GUITest.c"
	BOOL	RETVAL;
	dXSTARG;
#line 1001 "GUITest.xs"
	XQueryPointer(TheXDisplay, RootWindow(TheXDisplay, TheScreen),
				  &root, &child, &root_x, &root_y,
				  &win_x, &win_y, &mask);
	switch (button) {
	case Button1:
		RETVAL = (mask & Button1Mask);
		break;
	case Button2:
		RETVAL = (mask & Button2Mask);
		break;
	case Button3:
		RETVAL = (mask & Button3Mask);
		break;
	case Button4:
		RETVAL = (mask & Button4Mask);
		break;
	case Button5:
		RETVAL = (mask & Button5Mask);
		break;
	default:
		RETVAL = FALSE;
		break;
	};
#line 1454 "GUITest.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_X11__GUITest_IsWindowCursor); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest_IsWindowCursor)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "win, cursor");
    {
	Window	win = (Window)SvUV(ST(0))
;
	Cursor	cursor = (Cursor)SvUV(ST(1))
;
	BOOL	RETVAL;
	dXSTARG;
#line 1032 "GUITest.xs"
	OldErrorHandler = XSetErrorHandler(IgnoreBadWindow);
	RETVAL = XTestCompareCursorWithWindow(TheXDisplay, win, cursor);
	XSetErrorHandler(OldErrorHandler);
#line 1479 "GUITest.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_X11__GUITest_IsWindow); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest_IsWindow)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "win");
    {
	Window	win = (Window)SvUV(ST(0))
;
	BOOL	RETVAL;
	dXSTARG;
#line 1042 "GUITest.xs"
	RETVAL = IsWindowImp(win);
#line 1500 "GUITest.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_X11__GUITest_IsWindowViewable); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest_IsWindowViewable)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "win");
    {
	Window	win = (Window)SvUV(ST(0))
;
#line 1051 "GUITest.xs"
	XWindowAttributes wattrs = {0};
#line 1519 "GUITest.c"
	BOOL	RETVAL;
	dXSTARG;
#line 1053 "GUITest.xs"
	OldErrorHandler = XSetErrorHandler(IgnoreBadWindow);
	if (!XGetWindowAttributes(TheXDisplay, win, &wattrs)) {
		RETVAL = FALSE;
	} else { 
		RETVAL = (wattrs.map_state == IsViewable);
	}
	XSetErrorHandler(OldErrorHandler);
#line 1530 "GUITest.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_X11__GUITest_MoveWindow); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest_MoveWindow)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "win, x, y");
    {
	Window	win = (Window)SvUV(ST(0))
;
	int	x = (int)SvIV(ST(1))
;
	int	y = (int)SvIV(ST(2))
;
	BOOL	RETVAL;
	dXSTARG;
#line 1070 "GUITest.xs"
	OldErrorHandler = XSetErrorHandler(IgnoreBadWindow);
	RETVAL = XMoveWindow(TheXDisplay, win, x, y);
	XSync(TheXDisplay, False);
	XSetErrorHandler(OldErrorHandler);
#line 1558 "GUITest.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_X11__GUITest_ResizeWindow); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest_ResizeWindow)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "win, w, h");
    {
	Window	win = (Window)SvUV(ST(0))
;
	int	w = (int)SvIV(ST(1))
;
	int	h = (int)SvIV(ST(2))
;
	BOOL	RETVAL;
	dXSTARG;
#line 1084 "GUITest.xs"
	OldErrorHandler = XSetErrorHandler(IgnoreBadWindow);
	RETVAL = XResizeWindow(TheXDisplay, win, w, h);
	XSync(TheXDisplay, False);
	XSetErrorHandler(OldErrorHandler);
#line 1586 "GUITest.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_X11__GUITest_IconifyWindow); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest_IconifyWindow)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "win");
    {
	Window	win = (Window)SvUV(ST(0))
;
#line 1096 "GUITest.xs"
	XWindowAttributes wattrs = {0};
	int scr_num;
#line 1606 "GUITest.c"
	BOOL	RETVAL;
	dXSTARG;
#line 1099 "GUITest.xs"
	OldErrorHandler = XSetErrorHandler(IgnoreBadWindow);
	if (XGetWindowAttributes(TheXDisplay, win, &wattrs)) {
		for (scr_num = ScreenCount(TheXDisplay) - 1;
		     scr_num >= 0 ; --scr_num)
		{
			if ( wattrs.screen
			  == ScreenOfDisplay(TheXDisplay, scr_num))
			{
				break;
			}
			/* There is something really wrong with the Xlib data
			   if this "assert" fails. */
			assert(0 != scr_num);
		}
		RETVAL = XIconifyWindow(TheXDisplay, win, scr_num);
		XSync(TheXDisplay, False);
	} else {
		RETVAL = (BOOL) 0;
	}
	XSetErrorHandler(OldErrorHandler);
#line 1630 "GUITest.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_X11__GUITest_UnIconifyWindow); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest_UnIconifyWindow)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "win");
    {
	Window	win = (Window)SvUV(ST(0))
;
	BOOL	RETVAL;
	dXSTARG;
#line 1127 "GUITest.xs"
	OldErrorHandler = XSetErrorHandler(IgnoreBadWindow);
	RETVAL = XMapWindow(TheXDisplay, win);
	XSync(TheXDisplay, False);
	XSetErrorHandler(OldErrorHandler);
#line 1654 "GUITest.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_X11__GUITest_RaiseWindow); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest_RaiseWindow)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "win");
    {
	Window	win = (Window)SvUV(ST(0))
;
	BOOL	RETVAL;
	dXSTARG;
#line 1139 "GUITest.xs"
	OldErrorHandler = XSetErrorHandler(IgnoreBadWindow);
	RETVAL = XRaiseWindow(TheXDisplay, win);
	XSync(TheXDisplay, False);
	XSetErrorHandler(OldErrorHandler);
#line 1678 "GUITest.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_X11__GUITest_LowerWindow); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest_LowerWindow)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "win");
    {
	Window	win = (Window)SvUV(ST(0))
;
	BOOL	RETVAL;
	dXSTARG;
#line 1151 "GUITest.xs"
	OldErrorHandler = XSetErrorHandler(IgnoreBadWindow);
	RETVAL = XLowerWindow(TheXDisplay, win);
	XSync(TheXDisplay, False);
	XSetErrorHandler(OldErrorHandler);
#line 1702 "GUITest.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_X11__GUITest_GetInputFocus); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest_GetInputFocus)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 1162 "GUITest.xs"
	Window focus = 0;
	int revert = 0;
#line 1720 "GUITest.c"
	Window	RETVAL;
	dXSTARG;
#line 1165 "GUITest.xs"
	XGetInputFocus(TheXDisplay, &focus, &revert);
	RETVAL = focus;
#line 1726 "GUITest.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_X11__GUITest_SetInputFocus); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest_SetInputFocus)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "win");
    {
	Window	win = (Window)SvUV(ST(0))
;
#line 1175 "GUITest.xs"
	Window focus = 0;
	int revert = 0;
#line 1746 "GUITest.c"
	BOOL	RETVAL;
	dXSTARG;
#line 1178 "GUITest.xs"
	OldErrorHandler = XSetErrorHandler(IgnoreBadWindow);
	/* Note: Per function man page, there is no effect if the time parameter
	 *  	 of this call isn't accurate.  Will use CurrentTime.  Also, it
	 *		 appears that we can't trust its return value. */
	XSetInputFocus(TheXDisplay, win, RevertToParent, CurrentTime);
	XSync(TheXDisplay, False);
	XSetErrorHandler(OldErrorHandler);
	/* Verify that the window now has focus.  Used to determine return value */
	XGetInputFocus(TheXDisplay, &focus, &revert);
	RETVAL = (focus == win);
#line 1760 "GUITest.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_X11__GUITest_GetWindowPos); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest_GetWindowPos)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "win");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Window	win = (Window)SvUV(ST(0))
;
#line 1196 "GUITest.xs"
	XWindowAttributes wattrs = {0};
	Window child = 0;
	int num_ret = 0, x = 0, y = 0, scr_num;
#line 1783 "GUITest.c"
#line 1200 "GUITest.xs"
	OldErrorHandler = XSetErrorHandler(IgnoreBadWindow);
	if (XGetWindowAttributes(TheXDisplay, win, &wattrs)) {
		XTranslateCoordinates(TheXDisplay, win, wattrs.root,
			0 - wattrs.border_width, 0 - wattrs.border_width,
			&x, &y, &child);
		EXTEND(SP, 6);
		PUSHs( sv_2mortal(newSViv((IV)x)) );
		PUSHs( sv_2mortal(newSViv((IV)y)) );
		PUSHs( sv_2mortal(newSViv((IV)wattrs.width)) );
		PUSHs( sv_2mortal(newSViv((IV)wattrs.height)) );
		PUSHs( sv_2mortal(newSViv((IV)wattrs.border_width)) );
		for (scr_num = ScreenCount(TheXDisplay) - 1;
		     scr_num >= 0 ; --scr_num)
		{
			if ( wattrs.screen
			  == ScreenOfDisplay(TheXDisplay, scr_num))
			{
				break;
			}
			/* There is something really wrong with the Xlib data
			   if this "assert" fails. */
			assert(0 != scr_num);
		}
		PUSHs( sv_2mortal(newSViv((IV)scr_num)) );
		num_ret = 6;
	}
	XSetErrorHandler(OldErrorHandler);
	XSRETURN(num_ret);
#line 1813 "GUITest.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_X11__GUITest_GetParentWindow); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest_GetParentWindow)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "win");
    {
	Window	win = (Window)SvUV(ST(0))
;
#line 1234 "GUITest.xs"
	Window parent = 0, *children = NULL, root = 0;
	UINT childcount = 0; 
#line 1832 "GUITest.c"
	Window	RETVAL;
	dXSTARG;
#line 1237 "GUITest.xs"
	RETVAL = 0;
	if (XQueryTree(TheXDisplay, win, &root, &parent, &children, &childcount)) {
		XFree(children);
		RETVAL = parent;		
	}
#line 1841 "GUITest.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_X11__GUITest_GetScreenRes); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest_GetScreenRes)
{
    dVAR; dXSARGS;
    if (items < 0 || items > 1)
       croak_xs_usage(cv,  "scr_num = NO_INIT");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	int	scr_num;
#line 1250 "GUITest.xs"
	int x = 0, y = 0, num_ret = 0;
#line 1861 "GUITest.c"

	if (items >= 1) {
	    scr_num = (int)SvIV(ST(0))
;
	}
#line 1252 "GUITest.xs"
	if (0 == items)
		scr_num = TheScreen;
	if (scr_num >= 0 && scr_num < ScreenCount(TheXDisplay)) {
		x = DisplayWidth(TheXDisplay, scr_num);
		y = DisplayHeight(TheXDisplay, scr_num);
		EXTEND(SP, 2);
		PUSHs( sv_2mortal(newSViv((IV)x)) );
		PUSHs( sv_2mortal(newSViv((IV)y)) );
		num_ret = 2;
	}
	XSRETURN(num_ret);
#line 1879 "GUITest.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_X11__GUITest_GetScreenDepth); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_X11__GUITest_GetScreenDepth)
{
    dVAR; dXSARGS;
    if (items < 0 || items > 1)
       croak_xs_usage(cv,  "scr_num = NO_INIT");
    {
	int	scr_num;
	int	RETVAL;
	dXSTARG;

	if (items >= 1) {
	    scr_num = (int)SvIV(ST(0))
;
	}
#line 1269 "GUITest.xs"
	if (0 == items)
		scr_num = TheScreen;
	if (scr_num >= 0 && scr_num < ScreenCount(TheXDisplay)) {
		RETVAL = DefaultDepth(TheXDisplay, scr_num);
	} else {
		RETVAL = -1;
	}
#line 1909 "GUITest.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_X11__GUITest); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_X11__GUITest)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("X11::GUITest::InitGUITest", XS_X11__GUITest_InitGUITest);
        newXS_deffile("X11::GUITest::DeInitGUITest", XS_X11__GUITest_DeInitGUITest);
        newXS_deffile("X11::GUITest::DefaultScreen", XS_X11__GUITest_DefaultScreen);
        newXS_deffile("X11::GUITest::ScreenCount", XS_X11__GUITest_ScreenCount);
        newXS_deffile("X11::GUITest::SetEventSendDelay", XS_X11__GUITest_SetEventSendDelay);
        newXS_deffile("X11::GUITest::GetEventSendDelay", XS_X11__GUITest_GetEventSendDelay);
        newXS_deffile("X11::GUITest::SetKeySendDelay", XS_X11__GUITest_SetKeySendDelay);
        newXS_deffile("X11::GUITest::GetKeySendDelay", XS_X11__GUITest_GetKeySendDelay);
        newXS_deffile("X11::GUITest::GetWindowName", XS_X11__GUITest_GetWindowName);
        newXS_deffile("X11::GUITest::SetWindowName", XS_X11__GUITest_SetWindowName);
        newXS_deffile("X11::GUITest::GetRootWindow", XS_X11__GUITest_GetRootWindow);
        newXS_deffile("X11::GUITest::GetChildWindows", XS_X11__GUITest_GetChildWindows);
        newXS_deffile("X11::GUITest::MoveMouseAbs", XS_X11__GUITest_MoveMouseAbs);
        newXS_deffile("X11::GUITest::GetMousePos", XS_X11__GUITest_GetMousePos);
        newXS_deffile("X11::GUITest::PressMouseButton", XS_X11__GUITest_PressMouseButton);
        newXS_deffile("X11::GUITest::ReleaseMouseButton", XS_X11__GUITest_ReleaseMouseButton);
        newXS_deffile("X11::GUITest::SendKeys", XS_X11__GUITest_SendKeys);
        newXS_deffile("X11::GUITest::PressKey", XS_X11__GUITest_PressKey);
        newXS_deffile("X11::GUITest::ReleaseKey", XS_X11__GUITest_ReleaseKey);
        newXS_deffile("X11::GUITest::PressReleaseKey", XS_X11__GUITest_PressReleaseKey);
        newXS_deffile("X11::GUITest::IsKeyPressed", XS_X11__GUITest_IsKeyPressed);
        newXS_deffile("X11::GUITest::IsMouseButtonPressed", XS_X11__GUITest_IsMouseButtonPressed);
        newXS_deffile("X11::GUITest::IsWindowCursor", XS_X11__GUITest_IsWindowCursor);
        newXS_deffile("X11::GUITest::IsWindow", XS_X11__GUITest_IsWindow);
        newXS_deffile("X11::GUITest::IsWindowViewable", XS_X11__GUITest_IsWindowViewable);
        newXS_deffile("X11::GUITest::MoveWindow", XS_X11__GUITest_MoveWindow);
        newXS_deffile("X11::GUITest::ResizeWindow", XS_X11__GUITest_ResizeWindow);
        newXS_deffile("X11::GUITest::IconifyWindow", XS_X11__GUITest_IconifyWindow);
        newXS_deffile("X11::GUITest::UnIconifyWindow", XS_X11__GUITest_UnIconifyWindow);
        newXS_deffile("X11::GUITest::RaiseWindow", XS_X11__GUITest_RaiseWindow);
        newXS_deffile("X11::GUITest::LowerWindow", XS_X11__GUITest_LowerWindow);
        newXS_deffile("X11::GUITest::GetInputFocus", XS_X11__GUITest_GetInputFocus);
        newXS_deffile("X11::GUITest::SetInputFocus", XS_X11__GUITest_SetInputFocus);
        newXS_deffile("X11::GUITest::GetWindowPos", XS_X11__GUITest_GetWindowPos);
        newXS_deffile("X11::GUITest::GetParentWindow", XS_X11__GUITest_GetParentWindow);
        newXS_deffile("X11::GUITest::GetScreenRes", XS_X11__GUITest_GetScreenRes);
        newXS_deffile("X11::GUITest::GetScreenDepth", XS_X11__GUITest_GetScreenDepth);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
